#ifndef _CLASSSQMATRIX_
#define _CLASSSQMATRIX_

template <class T>
class SqMatrix {
  private:
    unsigned int rows;
    unsigned int cols;
    T           *elements;
  public:
    SqMatrix(const unsigned int n) {
      rows     = n;
      cols     = n;
      elements = new T[n*n];
      for (int i=0; i<n*n; i++)
        elements[i] = (T)0; 
    }
    ~SqMatrix() {
      delete[] elements;
    }
    T* operator[](const unsigned int i) {
      return &elements[i*cols];
    }
};

#endif
